Esempio n. 1
0
        /// <summary>
        /// Implement this method as an external command for Revit.
        /// </summary>
        /// <param name="commandData">An object that is passed to the external application
        /// which contains data related to the command,
        /// such as the application object and active view.</param>
        /// <param name="message">A message that can be set by the external application
        /// which will be displayed if a failure or cancellation is returned by
        /// the external command.</param>
        /// <param name="elements">A set of elements to which the external application
        /// can add elements that are to be highlighted in case of failure or cancellation.</param>
        /// <returns>Return the status of the external command.
        /// A result of Succeeded means that the API external method functioned as expected.
        /// Cancelled can be used to signify that the user cancelled the external operation
        /// at some point. Failure should be returned if the application is unable to proceed with
        /// the operation.</returns>
        public virtual Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData
                                                        , ref string message, Autodesk.Revit.DB.ElementSet elements)
        {
            if (null == s_appCreation)
            {
                // share for class Intersection.
                s_appCreation = commandData.Application.Application.Create;
            }

            UIDocument             doc = commandData.Application.ActiveUIDocument;
            CombinableElementArray solids
                = new CombinableElementArray();

            ElementSet es = new ElementSet();

            foreach (ElementId elemId in es)
            {
                es.Insert(doc.Document.GetElement(elemId));
            }
            if (0 < es.Size)
            {
                foreach (Autodesk.Revit.DB.ElementId elementId in doc.Selection.GetElementIds())
                {
                    Autodesk.Revit.DB.Element element = doc.Document.GetElement(elementId);
                    System.Diagnostics.Trace.WriteLine(element.GetType().ToString());

                    GenericForm gf = element as GenericForm;
                    if (null != gf && !gf.IsSolid)
                    {
                        continue;
                    }

                    CombinableElement ce = element as CombinableElement;
                    if (null != ce)
                    {
                        solids.Append(ce);
                    }
                }

                if (solids.Size < 2)
                {
                    message = "At least 2 combinable elements should be selected.";
                    return(Autodesk.Revit.UI.Result.Failed);
                }

                doc.Document.CombineElements(solids);

                //The selected generic forms are joined, whether or not they overlap.
                return(Autodesk.Revit.UI.Result.Succeeded);
            }

            AutoJoin autojoin = new AutoJoin();

            autojoin.Join(doc.Document);
            //All overlapping generic forms are joined.

            return(Autodesk.Revit.UI.Result.Succeeded);
        }
Esempio n. 2
0
        /// <summary>
        /// Tell if the element A and B are overlapped.
        /// </summary>
        /// <param name="elementA">element A</param>
        /// <param name="elementB">element B</param>
        /// <returns>return true if A and B are overlapped, or else return false.</returns>
        public bool IsOverlapped(CombinableElement elementA, CombinableElement elementB)
        {
            if (elementA.Id.IntegerValue == elementB.Id.IntegerValue)
            {
                return false;
            }

            Options geOptions = Command.s_appCreation.NewGeometryOptions();
            return Intersection.IsOverlapped(elementA.get_Geometry(geOptions), elementB.get_Geometry(geOptions));
        }
Esempio n. 3
0
        /// <summary>
        /// Tell if the element A and B are overlapped.
        /// </summary>
        /// <param name="elementA">element A</param>
        /// <param name="elementB">element B</param>
        /// <returns>return true if A and B are overlapped, or else return false.</returns>
        public bool IsOverlapped(CombinableElement elementA, CombinableElement elementB)
        {
            if (elementA.Id.IntegerValue == elementB.Id.IntegerValue)
            {
                return(false);
            }

            Options geOptions = Command.s_appCreation.NewGeometryOptions();

            return(Intersection.IsOverlapped(elementA.get_Geometry(geOptions), elementB.get_Geometry(geOptions)));
        }
Esempio n. 4
0
        /// <summary>
        /// Join geometry between overlapping solids.
        /// </summary>
        /// <param name="document">The active document</param>
        /// <returns>The number of geometry combination be joined in this document.</returns>
        public int Join(Document document)
        {
            int combinated = 0;

            // CombinableElement is of an element type that exists in the API, but not in Revit's native object model.
            // We use a combination of GenericForm and GeomCombination elements instead to find all CombinableElement.
            LogicalOrFilter filter = new LogicalOrFilter(
                new ElementClassFilter(typeof(GenericForm)),
                new ElementClassFilter(typeof(GeomCombination)));

            FilteredElementIterator itor = (new FilteredElementCollector(document)).WherePasses(filter).GetElementIterator();

            itor.Reset();
            while (itor.MoveNext())
            {
                GenericForm gf = itor.Current as GenericForm;
                if (null != gf && !gf.IsSolid)
                {
                    continue;
                }

                CombinableElement ce = itor.Current as CombinableElement;
                if (null == ce)
                {
                    continue;
                }
                else
                {
                    m_elements.Add(ce);
                }
            }
            // Added all solid forms in this document.

            while (1 < m_elements.Count)
            {
                GeomCombination geomCombination = JoinOverlapping(m_elements, document);
                if (null == geomCombination)
                {
                    return(combinated);//No overlapping.
                }

                combinated++;
            }

            return(combinated);
        }
Esempio n. 5
0
        private void Stream( ArrayList data, CombinableElement combElem )
        {
            data.Add( new Snoop.Data.ClassSeparator( typeof( CombinableElement ) ) );

              data.Add( new Snoop.Data.Enumerable( "Combinations", combElem.Combinations ) );

              GenericForm genForm = combElem as GenericForm;
              if( genForm != null )
              {
            Stream( data, genForm );
            return;
              }

              GeomCombination geomComb = combElem as GeomCombination;
              if( geomComb != null )
              {
            Stream( data, geomComb );
            return;
              }
        }